spool 919_Triggers.log;

/*
Impide la modificacin de los campos FRANQUICIA y VIRTUAL en la tabla TIENDAS.
*/
CREATE or replace TRIGGER TIENDAS_TR1 
BEFORE UPDATE OF FRANQUICIA, VIRTUAL ON TIENDAS 
FOR EACH ROW

BEGIN
  IF 
    :new.FRANQUICIA <> :old.FRANQUICIA OR
    :new.VIRTUAL <> :old.VIRTUAL
  THEN
    RAISE_APPLICATION_ERROR (-20001, 'Campos franquicia y virtual no se pueden actualizar.');
  END IF;
   
END;
/

/*
Impide la modificacin de la ciudad de una tienda fsica.
*/
CREATE OR REPLACE TRIGGER TIENDAS_TR2
BEFORE UPDATE OF NOMBRE_CIUDAD ON TIENDAS 
FOR EACH ROW
BEGIN

  IF :old.VIRTUAL = 0 THEN
    raise_application_error (-20002, 'No se puede cambiar la ciudad de una tienda fsica.');
  END IF;

END;
/

/*
Actualiza la tabla ESTADISTICAS_DIRECCION cuando se altera el nmero de empleados
de una tienda para un mes concreto.
*/
CREATE OR REPLACE TRIGGER N_EMPLEADOS_TR1 
BEFORE UPDATE OF NUMERO_EMPLEADOS ON N_EMPLEADOS 

DECLARE
  rsp_temp STRING (200);
BEGIN
  PKG_EST_DIR.ACTLZR_EST_GLOBAL(rsp_temp);
END;
/

/*
Actualiza los valores en la tabla ESTADISTICAS_DIRECCION
cuando se eliminan ventas en la tabla de VENTAS.
*/
CREATE OR REPLACE TRIGGER VENTAS_TR1 
AFTER DELETE ON VENTAS 

DECLARE
  rsp_temp STRING (200);
BEGIN
   PKG_EST_DIR.ACTLZR_EST_GLOBAL(rsp_temp);
END;
/

/*
Impide la actualizacin de valores ya introducidos en la tabla VENTAS
*/
CREATE OR REPLACE TRIGGER VENTAS_TR2 
BEFORE UPDATE ON VENTAS 
BEGIN
  raise_application_error (-20003, 'No se pueden actualizar datos de ventas.');
END;
/

/*
Impide la modificacin del cdigo EAN13 de un producto ya introducido
*/
CREATE OR REPLACE TRIGGER PRODUCTOS_TR1
BEFORE UPDATE OF COD_EAN ON PRODUCTOS 
BEGIN
  raise_application_error (-20004, 'No se puede modificar el cdigo EAN13 de un producto.');
END;
/

spool off;



